var yup = require('yup')

var contactSchema = yup.object({
  name: yup.string()
    .required(),
  age: yup.number()
    .required()
    .positive()
    .integer(),
  email: yup.string()
    .email(),
  website: yup.string()
    .url(),
  createdOn: yup.date()
    .default(() => new Date())
})

contactSchema.cast({
  name: 'jimmy',
  age: '24',
  createdOn: '2014-09-23T19:25:25Z'
});

let contact = {
  name: 'jimmy',
  age: 24,
  email: 'jdog@cool.biz'
}

await contactSchema.isValid()
;

await contactSchema.validate(contact)
;

contact = {
  name: 'jimmy',
  email: 'jdog'
}

await contactSchema.validate(contact, { abortEarly: false });
